#
# Copyright 2025 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-mssql-incremental-export-restore-worker-runtime.json
#
# Do not edit this file manually!
#

from delphixpy.v1_11_44.web.objects.IncrementalExportRestoreWorkerRuntime import IncrementalExportRestoreWorkerRuntime
from delphixpy.v1_11_44 import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class MSSqlIncrementalExportRestoreWorkerRuntime(IncrementalExportRestoreWorkerRuntime):
    """
    *(extends*
    :py:class:`v1_11_44.web.vo.IncrementalExportRestoreWorkerRuntime` *)*
    Runtime properties for Incremental export restore workers for MSSQL
    databases.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("MSSqlIncrementalExportRestoreWorkerRuntime", True)
        self._restore_worker_state = (self.__undef__, True)
        self._last_update_timestamp = (self.__undef__, True)
        self._total_number_of_restores_completed = (self.__undef__, True)
        self._last_restore_time = (self.__undef__, True)
        self._last_restored_backup_set_uuid = (self.__undef__, True)
        self._status = (self.__undef__, True)
        self._response = (self.__undef__, True)
        self._pending_action = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        obj._restore_worker_state = (data.get("restoreWorkerState", obj.__undef__), dirty)
        if obj._restore_worker_state[0] is not None and obj._restore_worker_state[0] is not obj.__undef__:
            assert isinstance(obj._restore_worker_state[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._restore_worker_state[0], type(obj._restore_worker_state[0])))
            assert obj._restore_worker_state[0] in ['ACTIVE', 'INACTIVE', 'FAULTED', 'UNKNOWN'], "Expected enum ['ACTIVE', 'INACTIVE', 'FAULTED', 'UNKNOWN'] but got %s" % obj._restore_worker_state[0]
            common.validate_format(obj._restore_worker_state[0], "None", None, None)
        obj._last_update_timestamp = (data.get("lastUpdateTimestamp", obj.__undef__), dirty)
        if obj._last_update_timestamp[0] is not None and obj._last_update_timestamp[0] is not obj.__undef__:
            assert isinstance(obj._last_update_timestamp[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._last_update_timestamp[0], type(obj._last_update_timestamp[0])))
            common.validate_format(obj._last_update_timestamp[0], "None", None, None)
        obj._total_number_of_restores_completed = (data.get("totalNumberOfRestoresCompleted", obj.__undef__), dirty)
        if obj._total_number_of_restores_completed[0] is not None and obj._total_number_of_restores_completed[0] is not obj.__undef__:
            assert isinstance(obj._total_number_of_restores_completed[0], int), ("Expected one of ['integer'], but got %s of type %s" % (obj._total_number_of_restores_completed[0], type(obj._total_number_of_restores_completed[0])))
            common.validate_format(obj._total_number_of_restores_completed[0], "None", None, None)
        obj._last_restore_time = (data.get("lastRestoreTime", obj.__undef__), dirty)
        if obj._last_restore_time[0] is not None and obj._last_restore_time[0] is not obj.__undef__:
            assert isinstance(obj._last_restore_time[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._last_restore_time[0], type(obj._last_restore_time[0])))
            common.validate_format(obj._last_restore_time[0], "None", None, None)
        obj._last_restored_backup_set_uuid = (data.get("lastRestoredBackupSetUUID", obj.__undef__), dirty)
        if obj._last_restored_backup_set_uuid[0] is not None and obj._last_restored_backup_set_uuid[0] is not obj.__undef__:
            assert isinstance(obj._last_restored_backup_set_uuid[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._last_restored_backup_set_uuid[0], type(obj._last_restored_backup_set_uuid[0])))
            common.validate_format(obj._last_restored_backup_set_uuid[0], "None", None, None)
        obj._status = (data.get("status", obj.__undef__), dirty)
        if obj._status[0] is not None and obj._status[0] is not obj.__undef__:
            assert isinstance(obj._status[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._status[0], type(obj._status[0])))
            common.validate_format(obj._status[0], "None", None, None)
        obj._response = (data.get("response", obj.__undef__), dirty)
        if obj._response[0] is not None and obj._response[0] is not obj.__undef__:
            assert isinstance(obj._response[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._response[0], type(obj._response[0])))
            common.validate_format(obj._response[0], "None", None, None)
        obj._pending_action = (data.get("pendingAction", obj.__undef__), dirty)
        if obj._pending_action[0] is not None and obj._pending_action[0] is not obj.__undef__:
            assert isinstance(obj._pending_action[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._pending_action[0], type(obj._pending_action[0])))
            common.validate_format(obj._pending_action[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "restore_worker_state" == "type" or (self.restore_worker_state is not self.__undef__ and (not (dirty and not self._restore_worker_state[1]))):
            dct["restoreWorkerState"] = dictify(self.restore_worker_state)
        if "last_update_timestamp" == "type" or (self.last_update_timestamp is not self.__undef__ and (not (dirty and not self._last_update_timestamp[1]))):
            dct["lastUpdateTimestamp"] = dictify(self.last_update_timestamp)
        if "total_number_of_restores_completed" == "type" or (self.total_number_of_restores_completed is not self.__undef__ and (not (dirty and not self._total_number_of_restores_completed[1]))):
            dct["totalNumberOfRestoresCompleted"] = dictify(self.total_number_of_restores_completed)
        if "last_restore_time" == "type" or (self.last_restore_time is not self.__undef__ and (not (dirty and not self._last_restore_time[1]))):
            dct["lastRestoreTime"] = dictify(self.last_restore_time)
        if "last_restored_backup_set_uuid" == "type" or (self.last_restored_backup_set_uuid is not self.__undef__ and (not (dirty and not self._last_restored_backup_set_uuid[1]))):
            dct["lastRestoredBackupSetUUID"] = dictify(self.last_restored_backup_set_uuid)
        if "status" == "type" or (self.status is not self.__undef__ and (not (dirty and not self._status[1]))):
            dct["status"] = dictify(self.status)
        if "response" == "type" or (self.response is not self.__undef__ and (not (dirty and not self._response[1]))):
            dct["response"] = dictify(self.response)
        if "pending_action" == "type" or (self.pending_action is not self.__undef__ and (not (dirty and not self._pending_action[1]))):
            dct["pendingAction"] = dictify(self.pending_action)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._restore_worker_state = (self._restore_worker_state[0], True)
        self._last_update_timestamp = (self._last_update_timestamp[0], True)
        self._total_number_of_restores_completed = (self._total_number_of_restores_completed[0], True)
        self._last_restore_time = (self._last_restore_time[0], True)
        self._last_restored_backup_set_uuid = (self._last_restored_backup_set_uuid[0], True)
        self._status = (self._status[0], True)
        self._response = (self._response[0], True)
        self._pending_action = (self._pending_action[0], True)

    def is_dirty(self):
        return any([self._restore_worker_state[1], self._last_update_timestamp[1], self._total_number_of_restores_completed[1], self._last_restore_time[1], self._last_restored_backup_set_uuid[1], self._status[1], self._response[1], self._pending_action[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, MSSqlIncrementalExportRestoreWorkerRuntime):
            return False
        return super().__eq__(other) and \
               self.restore_worker_state == other.restore_worker_state and \
               self.last_update_timestamp == other.last_update_timestamp and \
               self.total_number_of_restores_completed == other.total_number_of_restores_completed and \
               self.last_restore_time == other.last_restore_time and \
               self.last_restored_backup_set_uuid == other.last_restored_backup_set_uuid and \
               self.status == other.status and \
               self.response == other.response and \
               self.pending_action == other.pending_action

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def restore_worker_state(self):
        """
        Indicates the current state of the restore worker. *(permitted values:
        ACTIVE, INACTIVE, FAULTED, UNKNOWN)*

        :rtype: ``str``
        """
        return self._restore_worker_state[0]

    @restore_worker_state.setter
    def restore_worker_state(self, value):
        self._restore_worker_state = (value, True)

    @property
    def last_update_timestamp(self):
        """
        Timestamp of the last update to the status.

        :rtype: ``str``
        """
        return self._last_update_timestamp[0]

    @last_update_timestamp.setter
    def last_update_timestamp(self, value):
        self._last_update_timestamp = (value, True)

    @property
    def total_number_of_restores_completed(self):
        """
        Total number of restores the restore worker has completed.

        :rtype: ``int``
        """
        return self._total_number_of_restores_completed[0]

    @total_number_of_restores_completed.setter
    def total_number_of_restores_completed(self, value):
        self._total_number_of_restores_completed = (value, True)

    @property
    def last_restore_time(self):
        """
        Timestamp of the last restore completed by the restore worker.

        :rtype: ``str``
        """
        return self._last_restore_time[0]

    @last_restore_time.setter
    def last_restore_time(self, value):
        self._last_restore_time = (value, True)

    @property
    def last_restored_backup_set_uuid(self):
        """
        UUID of the database backup that was restored by the restore worker.

        :rtype: ``str``
        """
        return self._last_restored_backup_set_uuid[0]

    @last_restored_backup_set_uuid.setter
    def last_restored_backup_set_uuid(self, value):
        self._last_restored_backup_set_uuid = (value, True)

    @property
    def status(self):
        """
        The status of the restore worker run.

        :rtype: ``str``
        """
        return self._status[0]

    @status.setter
    def status(self, value):
        self._status = (value, True)

    @property
    def response(self):
        """
        Response taken based on the status of the restore worker run.

        :rtype: ``str``
        """
        return self._response[0]

    @response.setter
    def response(self, value):
        self._response = (value, True)

    @property
    def pending_action(self):
        """
        User action required to resolve any error that the restore worker run
        encountered.

        :rtype: ``str``
        """
        return self._pending_action[0]

    @pending_action.setter
    def pending_action(self, value):
        self._pending_action = (value, True)

